//##
//##	File:		CustomGrow.c
//##
//##	Author:		Takenori Kabeya
//##
//##	Version:	GlueWindowINIT3 version 3.0.7
//##				CutomGrow.c	- 1.0.1
//##				May 11, 1996.
//##
//##	E-mail:		kabeya@kuic.kyoto-u.ac.jp
//##				GBH06222@niftyserve.or.jp
//##
//##	##	All comment is written in both English and Japanese.
//##		Of course, in Samurai English!
//##
#include	"CustomGrow.h"

#include	"GW_INIT.h"
#include	"MarqueePort.h"


//##
//##	Declarations : Prototypes Of Static Functions
//##
//##	W[֐̃vg^Cv錾
//##
static void
ResizeGrowMarquee(
	WindowPtr		inWindowP,
	Point			inStartPt,
	const Rect*		inLimitRectP,
	Point*			outNewSizeP );

static void
ReplaceIntoGrowLimitRect(
	const Rect*		inLimitRectP,
	Point*			ioNewSizeBoxPtP );

static void
AdjustMarqueeSize(
	WindowPeek		inWindowPeek,
	Point			inGap,
	Point*			ioNewSizeBoxPtP,
	Boolean*		ioIsChangedHP,
	Boolean*		ioIsChangedVP );

static void
SetupGrowLimitRect(
	WindowPtr	inWindowP,
	Rect*		ioLimitRectP );



#pragma mark ===== Replace Functions =====
//##
//##	MEMO:
//##		When we call 'WDEF' without WindowManager,
//##		we need setup WMgrPort & CWMgrPort.
//##
//##		To setup WMgrPort & CWMgrPort is.... see code ( sorry! ).
//##		
//##
//##		WindowManager̃|[gɂāB
//##
//##		WDEF ƂƂɂ́AwDrawbZ[WA
//##		J[ WDEF Ȃ GetCWMgrPort() ĂŁÃ|[g
//##		JgɂAƂӂɂȂĂ邯ǁiWDEF
//##		͂Ȃ̂ŏڂ͒m񂯂ǁjA͂ǂWDEFĂԑA
//##		WindowManager̃|[gݒ肵ĂKv݂B
//##
//##		WMgrPort̓j^Ŝ𕢂|[gAIMȂǂɂ͏Ă邯ǁA
//##		ۂ́AɃj^Ŝ𕢂Ă킯ł͂ȂāAWindowManager
//##		Ɨpɑ傫wip^[ȂǂKXύXĂB
//##
//##		ŁÂŁÂ悤WindowManager WDEF ĂԂ悤
//##		ꍇAOŃj^Ŝ𕢂悤ȃ|[gpӂĂKvi炵jB
//##
//##		AJ[|[gƔ|[g͕ʁXɗpӂĂ̂ŁAݒ肵Ă
//##		Kvi炵jBWDEF }[L[ǂɕ`́AĂяoł
//##		Ȃi^Cgo[̃hbǑ̓J[|[gAȊO͂ǂ
//##		|[gɕ`悤jB
//##
//##		RA}[L[`IÃ|[gɖ߂ĂB
//##

#pragma mark ........ Public Functions ........
//
//	Custom grow-window routine which traps Toolbox GrowWindow.
//
//	IWiGrowWindow()ƒuAƎGrowWindow()[`B
//	ׂ̃EBhEƂ悤ɃhbOB
//
//	MEMO:
//		Not same as GlueWindow4.x.x or old GlueWindowINIT3,
//		now this routine doesn't draw marquee itself any longer.
//		'WDEF' do.
//
//		GlueWindowINIT3(3.0.4)܂ł́AŃ}[L[`ĂA
//		WDEFsƂiCÂȂājB
//
//		TCYKɒ߂AWDEFɃp[^nB
//
SInt32
CustomGrowWindow(
	WindowPtr	inWindowP,
	Point		inMousePt,
	Rect*		inLimitSizeP )
{
	GrafPtr		theSavedPortP;
	GrafPtr		theSavedWMgrPortP;
	GrafPort	theWorkWMgrPort;
	CGrafPtr	theSavedCWMgrPortP;
	CGrafPort	theWorkCWMgrPort;
	Point		theNewSize;
	Point		theOldSize;
	SInt32		theVHWindowSizeToReturn;
	Rect		theLimitRect = *inLimitSizeP;
	
	//
	//	Setup window / marquee size limit.
	//
	//	}[L[̑傫͈̐͂𐳂ݒ肷B
	//
	SetupGrowLimitRect( inWindowP, &theLimitRect );
	
	GetPort( &theSavedPortP );
	
	//
	//	Setup WindowManagerPort ( B/W )
	//
	//	p WindowManagerPort ̐ݒB
	OpenMarqueePort( &theWorkWMgrPort );
	theSavedWMgrPortP = LMGetWMgrPort();
	LMSetWMgrPort( &theWorkWMgrPort );
	
	//
	//	Setup WindowManagerPort ( Color )
	//
	if( gIsColorAvailable ) {
		//	J[p WindowManagerPort ̐ݒB
		OpenMarqueeCPort( &theWorkCWMgrPort );
		theSavedCWMgrPortP = LMGetCWMgrPort();
		LMSetCWMgrPort( &theWorkCWMgrPort );
	}
	
	//
	//	Resize marquee as it glues.
	//
	ResizeGrowMarquee( inWindowP, inMousePt, &theLimitRect, &theNewSize );
	
	//
	//	Restore WindowManager ports.
	//
	//	WindowManager̃|[gɖ߂B
	if( gIsColorAvailable ) {
		LMSetCWMgrPort( theSavedCWMgrPortP );
		CloseCPort( &theWorkCWMgrPort );
	}
	LMSetWMgrPort(  theSavedWMgrPortP );
	ClosePort(  &theWorkWMgrPort );
	
	SetPort( theSavedPortP );
	//
	//	Calc return value ( new window size ).
	//
	//	ԂliEBhẼTCYjvZB
	//
	theOldSize.h = inWindowP->portRect.right  - inWindowP->portRect.left;
	theOldSize.v = inWindowP->portRect.bottom - inWindowP->portRect.top;
	
	theVHWindowSizeToReturn = 0;
	//
	//	if size is changed,
	//
	//	TCYςĂȂA
	if( theOldSize.h != theNewSize.h ||
		theOldSize.v != theNewSize.v ) {
		
		theVHWindowSizeToReturn =  theNewSize.v;
		theVHWindowSizeToReturn <<=	16;
		theVHWindowSizeToReturn += theNewSize.h;
	}
	
	return( theVHWindowSizeToReturn );
}



#pragma mark ........ Private Functions ........
//
//	Track marquee as it glues.
//
//	}[L[ׂ̃EBhEɂ悤
//	[`B
//
void
ResizeGrowMarquee(
	WindowPtr		inWindowP,
	Point			inStartPt,
	const Rect*		inLimitRectP,
	Point*			outNewSizeP )
{
	Boolean			isChangedH;
	Boolean			isChangedV;
	Point			theGap;
	Point			theNewSizeBoxPt;
	Point			theOldSizeBoxPt;
	Point			theMouseToSizeBox;
	Rect			theFrameRect;
	WindowPeek		theWindowPeek;
	Point			theMousePt  = inStartPt;
	WindowDefUPP	theWDEFProc = NewWindowDefProc(
									*( ( WindowPeek )inWindowP )->windowDefProc );
	SInt16			theVarCode  = GetWVariant( inWindowP );
	
	theOldSizeBoxPt.h = GetContRgnBBox( inWindowP ).right;
	theOldSizeBoxPt.v = GetContRgnBBox( inWindowP ).bottom;
	
	theMouseToSizeBox = theOldSizeBoxPt;
	SubPt( theMousePt, &theMouseToSizeBox );
	
	theFrameRect = GetContRgnBBox(  inWindowP );
	
	theGap.h = GetStrucRgnBBox( inWindowP ).right  - theFrameRect.right;
	theGap.v = GetStrucRgnBBox( inWindowP ).bottom - theFrameRect.bottom;
	
	//
	//	Draw marquee ( I haven't check on PowerPC Compiler yet ).
	//
	//	܂}[L[`B
	//
	( *theWDEFProc )( theVarCode, inWindowP, wGrow, ( SInt32 )&theFrameRect );
	
	while( StillDown() ) {
		GetMouse( &theMousePt );
		LocalToGlobal( &theMousePt );
		
		theNewSizeBoxPt.h = theMousePt.h + theMouseToSizeBox.h;
		theNewSizeBoxPt.v = theMousePt.v + theMouseToSizeBox.v;
	
		ReplaceIntoGrowLimitRect( inLimitRectP, &theNewSizeBoxPt );
		
		isChangedH = false;
		isChangedV = false;
			
		theWindowPeek = ( WindowPeek )FrontWindow();
		while( theWindowPeek != nil ) {
			if( theWindowPeek != ( WindowPeek )inWindowP ) {
				
				AdjustMarqueeSize( theWindowPeek, theGap, &theNewSizeBoxPt,
								   &isChangedH, &isChangedV );
				
				if( isChangedH && isChangedV ) {
					break;
				}
			}
			theWindowPeek = theWindowPeek->nextWindow;
		}
		
		//
		//	TCY{bNXĂȂ}[L[`ȂB
		///
		if( !EqualPt( theNewSizeBoxPt, theOldSizeBoxPt ) ) {
			
			//
			//	}[L[B
			//
			( *theWDEFProc )( theVarCode, inWindowP, wGrow, ( SInt32 )&theFrameRect );
			
			//
			//	}[L[̃TCYύXB
			//
			theFrameRect.right  = theNewSizeBoxPt.h;
			theFrameRect.bottom = theNewSizeBoxPt.v;
			//
			//	}[L[`B
			//
			( *theWDEFProc )( theVarCode, inWindowP, wGrow, ( SInt32 )&theFrameRect );
			
			theOldSizeBoxPt = theNewSizeBoxPt;
		}
	}
	
	//
	//	ŌɃ}[L[B
	//
	( *theWDEFProc )( theVarCode, inWindowP, wGrow,
							  ( SInt32 )&theFrameRect );
	
	outNewSizeP->h = theFrameRect.right  - theFrameRect.left;
	outNewSizeP->v = theFrameRect.bottom - theFrameRect.top;
	DisposeRoutineDescriptor( theWDEFProc );
}




//
//	If right-bottom of marquee is outside the limit region,
//	replace it in limit region.
//
//
//	͈͂TCY{bNX͂ݏoĂȂ
//	AĎ郋[`B
//	͂ݏoĂ琧͈͓̂Ƃ߂_
//	ݒ肵B
//
void
ReplaceIntoGrowLimitRect(
	const Rect*		inLimitRectP,
	Point*			ioNewSizeBoxPtP )
{
	SInt32	theVHCoordinates;
	
	theVHCoordinates = PinRect( inLimitRectP, *ioNewSizeBoxPtP );
	ioNewSizeBoxPtP->h = LoWord( theVHCoordinates );
	ioNewSizeBoxPtP->v = HiWord( theVHCoordinates );
}



//
//	Adjust marquee size as it glues to the next window.
//
//	EBhȆ傫ÃׂEBhE
//	悤ɐ䂷郋[`B
//
void
AdjustMarqueeSize(
	WindowPeek		inWindowPeek,
	Point			inGap,
	Point*			ioNewSizeBoxPtP,
	Boolean*		ioIsChangedHP,
	Boolean*		ioIsChangedVP )
{
	Point	theFrame;
	Point	theNewSizeBoxPt = *ioNewSizeBoxPtP;
	Boolean	isChangedH = *ioIsChangedHP;
	Boolean	isChangedV = *ioIsChangedVP;
	Rect	theWindowRect = ( **inWindowPeek->strucRgn ).rgnBBox;
	
	theFrame.h = theNewSizeBoxPt.h + inGap.h;
	theFrame.v = theNewSizeBoxPt.v + inGap.v;
	
	if( !isChangedH && ( Abs( theFrame.h - theWindowRect.left	) <= kPixelsToGlue ) ) {
		theNewSizeBoxPt.h = theWindowRect.left - inGap.h;
		isChangedH = true;	//	̃EBhẺE[Ɨׂ̃EBhE̍[߂ƂB
	}
	if( !isChangedH && ( Abs( theFrame.h - theWindowRect.right ) <= kPixelsToGlue ) ) {
		theNewSizeBoxPt.h = theWindowRect.right - inGap.h;
		isChangedH = true;	//	̃EBhẺE[Ɨׂ̃EBhẺE[߂ƂB
	}
	if( !isChangedV && ( Abs( theFrame.v - theWindowRect.top ) <= kPixelsToGlue ) ) {
		theNewSizeBoxPt.v = theWindowRect.top - inGap.v;
		isChangedV = true;	//	̃EBhẺ[Ɨׂ̃EBhȄ[߂ƂB
	}
	if( !isChangedV && ( Abs( theFrame.v - theWindowRect.bottom ) <= kPixelsToGlue ) ) {
		theNewSizeBoxPt.v = theWindowRect.bottom - inGap.v;
		isChangedV = true;	//	̃EBhẺ[Ɨׂ̃EBhẺ[߂ƂB
	}
	
	*ioIsChangedHP = isChangedH;
	*ioIsChangedVP = isChangedV;
	*ioNewSizeBoxPtP = theNewSizeBoxPt;
}



//
//	Not same as drag limit, checking multi monitor is
//	not necessary ( I believe... ).
//
//	EBhȆ傫͈̐͂ݒ肷郋[`B
//	}EX̓𐧌͈͂AEBhE̒g
//	ƂTCY{bNX̉EĂ傫
//	ƂēnĂ̂ŁAO[o`ƂČvZ
//	B
//
void
SetupGrowLimitRect(
	WindowPtr	inWindowP,
	Rect*		ioLimitRectP )
{
	GrafPtr		theSavedPortP;
	Point		theGlobalPt;
	
	GetPort( &theSavedPortP );
	SetPort( inWindowP );
	
	theGlobalPt.h = inWindowP->portRect.left;
	theGlobalPt.v = inWindowP->portRect.top;
	LocalToGlobal( &theGlobalPt );
	
	ioLimitRectP->left   += theGlobalPt.h;
	ioLimitRectP->right  += theGlobalPt.h;
	ioLimitRectP->top    += theGlobalPt.v;
	ioLimitRectP->bottom += theGlobalPt.v;

	if( ioLimitRectP->right < ioLimitRectP->left ) {
		ioLimitRectP->right = 0x7FFF;
	}
	if( ioLimitRectP->bottom < ioLimitRectP->top ) {
		ioLimitRectP->bottom = 0x7FFF;
	}
	
	SetPort( theSavedPortP );
}
