//##
//##	File:		DragMarquee.c
//##
//##	Author:		Takenori Kabeya
//##
//##	Version:	GlueWindowINIT3 version 3.0.7
//##				DragMarquee.c	- 1.0
//##				May 11, 1996.
//##
//##	E-mail:		kabeya@kuic.kyoto-u.ac.jp
//##				GBH06222@niftyserve.or.jp
//##
#include	"DragMarquee.h"



RgnHandle
GetNewDragMarquee(
	RgnHandle	inWindowStrucRgnH,
	Point*		outSizeP,
	Point*		outGlobalPtP )
{
	RgnHandle	theRgnH = nil;
	
	if( inWindowStrucRgnH != nil &&
		outGlobalPtP != nil &&
		outSizeP != nil ) {
		
		theRgnH = NewRgn();
	
		if( theRgnH != nil ) {
			outGlobalPtP->h = ( **inWindowStrucRgnH ).rgnBBox.left;
			outGlobalPtP->v = ( **inWindowStrucRgnH ).rgnBBox.top;
		
			CopyRgn( inWindowStrucRgnH, theRgnH );
			OffsetRgn( theRgnH, - outGlobalPtP->h, - outGlobalPtP->v );
		
			outSizeP->h = ( **inWindowStrucRgnH ).rgnBBox.right -
						  outGlobalPtP->h;
			outSizeP->v = ( **inWindowStrucRgnH ).rgnBBox.bottom -
						  outGlobalPtP->v;
		}
	}
	return( theRgnH );
}

	
	
//
//	Set pen pattern to gray and pen mode to patXor
//	before you call this routine.
//
void
XorDragMarquee(
	RgnHandle	inMarqueeRgnH,
	Point		inGlobalPt,
	Boolean*	ioIsVisible )
{
	Point	theLocalPt = inGlobalPt;
	
	if( inMarqueeRgnH != nil ) {
		//
		//	FrameRgn() uses local coordinates, so trans.
		//
		//	FrameRgn()Ƃ̓[JWŕ`̂ŁA
		//	}[L[[JɕϊB
		//
		GlobalToLocal( &theLocalPt );
		OffsetRgn( inMarqueeRgnH, theLocalPt.h, theLocalPt.v );
		
		FrameRgn( inMarqueeRgnH );
		
		//
		//	trans reversely.
		//
		//	[J猳ɖ߂B
		//	
		OffsetRgn( inMarqueeRgnH, - theLocalPt.h, - theLocalPt.v );
		if( ioIsVisible != nil ) {
			*ioIsVisible = !( *ioIsVisible );
		}
	}
}



void
DisposeDragMarqueeRgn(
	RgnHandle	inMarqueeRgnH )
{
	if( inMarqueeRgnH != nil ) {
		DisposeRgn( inMarqueeRgnH );
	}
}
