//##
//##	File:		Environs.c
//##
//##	Author:		Takenori Kabeya
//##
//##	Version:	1.0
//##				May 11, 1996.
//##
//##	E-mail:		kabeya@kuic.kyoto-u.ac.jp
//##				GBH06222@niftyserve.or.jp
//##
//##	##	All comment is written in both English and Japanese.
//##		Of course, in Samurai English!
//##
#include	"Environs.h"



//##
//##	Declarations : Prototypes Of Static Functions
//##
//##	W[֐̃vg^Cv錾
//##
static TrapType
GetTrapType(
	SInt16	inTrap );

static SInt16
GetNumToolboxTrap( void );



//##
//##	Definitions : External Functions
//##
//##	֐̒`
//##

//
//	This code is found in Inside-Macintosh / THINK Reference.
//
//	Kvȃgbvɂ邩mF郋[`QB
//	THINK Reference'About Compatibility'蔲B
//
Boolean
IsTrapAvailable(
	SInt16		inTrap )
{
	SInt16		theTrap = inTrap;
	TrapType	theTrapType;
	
	theTrapType = GetTrapType( theTrap );
	if( theTrapType == ToolTrap ) {
		theTrap &= 0x07FF;
	}
	if( GetNumToolboxTrap() <= theTrap ) {
		theTrap = _Unimplemented;
	}
	
	return( NGetTrapAddress( theTrap, theTrapType ) !=
			NGetTrapAddress( _Unimplemented, ToolTrap ) );
}



Boolean
IsSystem7( void )
{
	OSErr		theErr;
	SInt32		theResponse;
	
	if( IsTrapAvailable( _Gestalt ) ) {
		theErr = Gestalt( gestaltSystemVersion, &theResponse );
		if( theErr == noErr && 0x0700 <= theResponse ) {
			return( true );
		}
	}
	return( false );
}



#define	kTrapMask		0x0800

TrapType
GetTrapType(
	SInt16  inTrap )
{
	if( 0 < ( inTrap & kTrapMask ) ) {
		return( ToolTrap );
	}
	return( OSTrap );
}



SInt16
GetNumToolboxTrap( void )
{
	if( NGetTrapAddress( _InitGraf, ToolTrap ) ==
		NGetTrapAddress( 0xAA6E, ToolTrap ) ) {
		
		return( 0x0200 );
	}
	return( 0x0400 );
}

#undef	kTrapMask
