//##
//##	File:		GW_INIT.c
//##
//##	Author:		Takenori Kabeya
//##
//##	Version:	GlueWindowINIT3 version 3.0.7
//##				GW_INIT.c	- 3.0.7
//##				May 11, 1996
//##
//##	E-mail:		kabeya@kuic.kyoto-u.ac.jp
//##				GBH06222@niftyserve.or.jp
//##
//##	NOTES:
//##	
//##	This program is developed based on 'GlueWindowINIT2' by Takuji Matsubara.
//##
//##	̃vO͏񎁍'GlueWindowINIT2'ƂɂĊJĂ܂B
//##
//##	##	All comment is written in both English and Japanese.
//##		Of course, in Samurai English!
//##
#include	"GW_INIT.h"

#include	"Environs.h"
#include	"CustomDrag.h"
#include	"CustomGrow.h"



//##
//##	Definitions : A4 Relative Global Variables
//##
//##	`SW[iO[ojϐ̒`錾
//##
//
//	QuickDraw global variable for personal use.
//
//	ƎɏQuickDrawϐB
//
QDGlobals	gQDGlobals;
Boolean		gIsColorAvailable;
pascal Boolean	( *OriginalTrackGoAwayProc )( WindowPtr, Point );
pascal void		( *OriginalDragWindowProc ) ( WindowPtr, Point, Rect* );
pascal SInt32	( *OriginalGrowWindowProc ) ( WindowPtr, Point, Rect* );



//##
//##	Declarations : Prototypes Of Static Functions
//##
//##	W[֐̃vg^Cv錾
//##
static void
SetupINIT( void );

static void
DrawIcon(
	SInt16	inIconID );

pascal Handle
Get1ResourceIntoSystemHeap(
	OSType	inResType,
	SInt16	inResID );

pascal void
DispatchDragWindow(
	WindowPtr	inWindowP,
	Point		inMousePt,
	Rect*		inLimitRectP );

pascal long
DispatchGrowWindow(
	WindowPtr	inWindowP,
	Point		inMousePt,
	Rect*		inLimitRectP );



#pragma mark ===== INIT Setup Functions =====
//## --------------------
//##	Setup INIT Code
//##
//##	INITZbgAbv
//## --------------------

//
//	This routine is executed once at startup.
//	To access global variables as A4 Relative, so we keep A4 registar value,
//	and then initialize globals.
//
//	MacintoshNɈxs郋[`B
//	O[oϐɂ`S΂ŃANZX̂
//	`SWX^̒lێAƎɎgpQuickDrawO[oB
//	uTHINK C vO~Ouvi{TVEZp]_ЊjQƁB
//
void
main( void )
{
	long	theOldA4;
	
	theOldA4 = SetCurrentA4();
	RememberA4();
	
	InitGraf( &gQDGlobals.thePort );
	SetupINIT();
	
	SetA4( theOldA4 );
}



//
//	Load this code into system heap, register custom routines to dispatch table,
//	judge what icon to show.
//
//	Ǝ̃hbO[`fBXpb`e[uɓo^A
//	܂Zbgł΃ACR\郋[`B
//
void
SetupINIT( void )
{
	Handle				theResH;
	UniversalProcPtr	theGrowAddress;
	UniversalProcPtr	theDragAddress;
	SInt16				theIconID = rcicn_OK;
	
	theResH = Get1ResourceIntoSystemHeap( 'INIT' , rINIT_GlueWindow );
	
	if( theResH != nil ) {
		HLock( theResH );
		HNoPurge( theResH );
		DetachResource( theResH );
		
		theDragAddress = ( UniversalProcPtr )StripAddress(
									NGetTrapAddress( _DragWindow,	ToolTrap ) );
		theGrowAddress = ( UniversalProcPtr )StripAddress(
									NGetTrapAddress( _GrowWindow,	ToolTrap ) );
		
		OriginalDragWindowProc	= ( pascal void(*)( WindowPtr, Point, Rect* ) )
																	theDragAddress;
		OriginalGrowWindowProc	= ( pascal SInt32 (*)( WindowPtr, Point, Rect* ) )
																	theGrowAddress;
		
		NSetTrapAddress( ( UniversalProcPtr )DispatchDragWindow,
													_DragWindow, ToolTrap );
		NSetTrapAddress( ( UniversalProcPtr )DispatchGrowWindow,
													_GrowWindow, ToolTrap );
	}
	else {
		theIconID = rcicn_NG;
	}
	
	DrawIcon( theIconID );
}



//
//	Draw startup icon with/without color. This routine is written by Takuji Matsubara.
//
//	X^[gAbvACR\郋[`B
//	MacPower'94 7́uL[r̃vO}[͂ȂXHv
//	B
//
void
DrawIcon(
	SInt16	inIconID )
{
	Handle		theIconH = nil;
	GrafPtr		theSavedPortP;
	GrafPort	theIconPort;
	Rect		theIconRect;
	SInt16		theScreenWidth;
	
	if( inIconID != rcicn_NO ) {
		
		//
		//	Some machines, like PowerBook100, doesn't have ColorQuickDraw functions.
		//	So check it before using GetCIcon, PlotCIcon, etc..
		//
		//	PowerBook100ȂǂɂGetCIconȂǁAColorQuickDraw̖߂
		//	[hȂ̂Ń`FbNB
		//
		gIsColorAvailable = IsTrapAvailable( _GetCIcon );
		if( gIsColorAvailable ) {
			theIconH = ( Handle )GetCIcon( inIconID );
		}
		else {
			theIconH = GetIcon( inIconID );
		}
		
		if( theIconH != nil ) {
			HNoPurge( theIconH );
			
			GetPort( &theSavedPortP );
			OpenPort( &theIconPort );
			SetPort( &theIconPort );
			
			if( ( ( iconLoc_h << 1 ) ^ 0x1021 ) != iconLoc_cs ) {
				iconLoc_h = 8;
			}
			
			theScreenWidth = ( ( theIconPort.portRect.right -
								 theIconPort.portRect.left ) / 40  ) * 40;
				
			theIconRect.left   = iconLoc_h % theScreenWidth;
			theIconRect.right  = theIconRect.left + 32;
			
			theIconRect.top    = theIconPort.portRect.bottom -
									( 40 * ( 1 + iconLoc_h / theScreenWidth ) );
			theIconRect.bottom = theIconRect.top + 32;
			
			if( gIsColorAvailable ) {
				PlotCIcon( &theIconRect, ( CIconHandle )theIconH );
				DisposeCIcon(  ( CIconHandle )theIconH );
			}
			else {
				PlotIcon( &theIconRect,  theIconH );
				DisposeHandle( theIconH );
			}
			
			iconLoc_h += 40;
			iconLoc_cs = ( iconLoc_h << 1 ) ^ 0x1021;
			
			SetPort( theSavedPortP );
			ClosePort( &theIconPort );
		}
	}
}



//
//	System heap version of Get1Resource.
//	Current heap will be restored.
//
//	VXeq[vɃ\[Xǂݍރ[`B
//	ǂݍ݂IAJgq[v͌ɖ߂B
//
pascal Handle
Get1ResourceIntoSystemHeap(
	OSType	inResType,
	SInt16	inResID )
{
	THz		theOldZone;
	Handle	theResH;
	
	theOldZone = GetZone();
	SetZone( SystemZone() );
	theResH = Get1Resource( inResType, inResID );
	SetZone( theOldZone );
	
	return( theResH );
}


/*
QDGlobals*
GetQDGlobals( void )
{
	SInt32		theOldA4;
	QDGlobals*	theGlobalP;
	
	theOldA4 = SetUpA4();
	
	theGlobalP = &sQDGlobals;
	
	RestoreA4( theOldA4 );
	
	return( theGlobalP );
}
*/

#pragma mark ===== Trap Functions =====
//##
//##	Toolbox trap routines
//##
//##	Toolboxgbv郋[`Q
//##

//
//	This routine is executed when _DragWindow A-Trap.
//	Dispatch to original DragWindow() and custom one
//	according to user's instruction ( keep modifier-keys 
//	down or not ).
//
//	`gbv_DragWindowĂ΂
//	ɔłB
//	IWiDragWindowƓƎDragWindow
//	U蕪B
//
pascal void
DispatchDragWindow(
	WindowPtr	inWindowP,
	Point		inMousePt,
	Rect*		inLimitRectP )
{
	SInt32		theOldA4;
	KeyMap		theKeyMap;
	Boolean		isCommandKeyDown;
	Boolean		isOptionKeyDown;
	
	theOldA4 = SetUpA4();
	
	//
	//	Activate the window when command-key up.
	//
	//	R}hL[ĂȂ
	//	EBhEANeBuɂB
	//
	//	NOTE:
	//		Original DragWindow() activate 'after'
	//		drag marquee.
	//		But I feel 'before' is cool. Of course,
	//		better one is 'after'.
	//
	//		IWiDragWindoẃAhbOA
	//		ANeBuɂ邪AlIɂ̓hbO
	//		Ô̕ł͂ȂƎvĂ邽߁A
	//		ɓꂿႤB
	//
	GetKeys( theKeyMap );
	isCommandKeyDown = BitTst( theKeyMap, keyBit_Command );
	if( !isCommandKeyDown ) {
		SelectWindow( inWindowP );
	}
	
	//
	//	When option-key down, call original DragWindow().
	//	Otherwise call custom drag-window-function.
	//
	//	IvVL[ĂƂ
	//	VXe{DragWindowĂсA
	//	łȂƎDragWindow
	//	ĂԁB
	//
	isOptionKeyDown = BitTst( theKeyMap, keyBit_Option );
	
	if( isOptionKeyDown ) {
		( *OriginalDragWindowProc )( inWindowP, inMousePt, inLimitRectP );
	}
	else {
		CustomDragWindow( inWindowP, inMousePt, inLimitRectP );
	}
	
	RestoreA4( theOldA4 );
}
	


//
//	Dispatch to original and custom DragWindow().
//
//	`gbv_GrowWindowĂ΂
//	ɔłB
//	IWiGrowWindowƓƎGrowWindow
//	U蕪B
//
pascal SInt32
DispatchGrowWindow(
	WindowPtr	inWindowP,
	Point		inMousePt,
	Rect*		inLimitRectP )
{
	SInt32	theOldA4;
	SInt32	theWindowSize;
	KeyMap	theKeyMap;
	Boolean	isOptionKeyDown;
	
	theOldA4 = SetUpA4();
	
	//
	//	When option is down, call original, otherwise custom.
	//
	//
	//	IvVL[ĂƂ
	//	IWiGrowWindowĂсA
	//	łȂƎGrowWindowĂԁB
	//
	GetKeys( theKeyMap );
	isOptionKeyDown = BitTst( theKeyMap, keyBit_Option );
	if( isOptionKeyDown ) {
		theWindowSize = ( *OriginalGrowWindowProc )( inWindowP, inMousePt,
													 inLimitRectP );
	}
	else {
		theWindowSize = CustomGrowWindow( inWindowP, inMousePt, inLimitRectP );
	}
	
	RestoreA4( theOldA4 );
	
	return( theWindowSize );
}
