//##
//##	File:		MarqueePort.c
//##
//##	Author:		Takenori Kabeya
//##
//##	Version:	1.0
//##				May 11, 1996.
//##
//##	E-mail:		kabeya@kuic.kyoto-u.ac.jp
//##				GBH06222@niftyserve.or.jp
//##

//##
//##	How to use:
//##		When you want to draw marquee outside windows, write code 
//##
//##	-----
//##
//##		GrafPtr		theSavedPortP;
//##		GrafPort	theMarqueePort;
//##		GetPort( &theSavedPortP );
//##		OpenMarqueePort( &theMarqueePort );
//##		SetPort( &theMarqueePort );
//##
//##		... your drawing marquee routine ...
//##
//##		SetPort( theSavedPortP );
//##		ClosePort( &theMarqueePort );
//##		//	or CloseMarqueePort( &theMarqueePort );
//##		
//##	-----
//##
//##		If you want to use color port, write code 
//##
//##		GrafPtr		theSavedPortP;
//##		CGrafPort	theMarqueeCPort;
//##		GetPort( &theSavedPortP );
//##		OpenMarqueeCPort( &theMarqueeCPort );
//##		SetPort( ( GrafPtr )&theMarqueePort );
//##
//##		... your drawing marquee routie ...
//##
//##		SetPort( theSavedPortP );
//##		CloseCPort( &theMarqueeCPort );
//##		//	or CloseMarqueeCPort( &theMarqueeCPort );
//##
//##

//##
//##	}[L[`߂̃|[gpӂ郂W[B
//##
//##	gF
//##		}[L[EBhE̊Oɕ`ȂƎvƂ
//##
//##		GrafPtr		theSavedPortP;
//##		GrafPort	theMarqueePort;
//##		GetPort( &theSavedPortP );
//##		OpenMarqueePort( &theMarqueePort );
//##		SetPort( &theMarqueePort );
//##
//##		ƂB
//##
//##		}[L[`IA
//##
//##		SetPort( theSavedPortP );
//##		ClosePort( &theMarqueePort );
//##		//	邢CloseMarqueePort( &theMarqueePort );
//##		
//##		ƂB
//##
//##		J[|[gJꍇ́A
//##
//##		GrafPtr		theSavedPortP;
//##		CGrafPort	theMarqueeCPort;
//##		GetPort( &theSavedPortP );
//##		OpenMarqueeCPort( &theMarqueeCPort );
//##		SetPort( ( GrafPtr )&theMarqueePort );
//##
//##		ŊJA
//##
//##		SetPort( theSavedPortP );
//##		CloseCPort( &theMarqueeCPort );
//##		//	邢CloseMarqueeCPort( &theMarqueeCPort );
//##
//##		ŕB
//##
#include	"MarqueePort.h"


//
//	This routine also sets pen size, pattern and mode.
//
void
OpenMarqueePort(
	GrafPort*	outMarqueePortP )
{
	RgnHandle	theGrayRgnH;
	Pattern		theGrayPat = { 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA };
	OpenPort( outMarqueePortP );
//	SetPort( outMarqueePortP );
	
	//
	//	Set port size to gray area size.
	//
	//	}[L[͉ʂς܂ŕ`̂ŁA
	//	}[L[`߂̃Ot|[g
	//	GrayRgn(fXNgbv̊DF̕jƓɂB
	//
	theGrayRgnH = GetGrayRgn();
	CopyRgn( theGrayRgnH, outMarqueePortP->visRgn );
	outMarqueePortP->portRect = ( **theGrayRgnH ).rgnBBox;
	
	//
	//	}[L[`߂̃y̐ݒB
	//
	ShowPen();
	PenSize( 1, 1 );
	PenPat( &theGrayPat );
	PenMode( notPatXor );
}



void
CloseMarqueePort(
	GrafPtr		inMarqueePortP )
{
	if( inMarqueePortP != nil ) {
		ClosePort( inMarqueePortP );
	}
}



//
//	This routine also sets pen size, pattern, mode.
//
void
OpenMarqueeCPort(
	CGrafPort*	outMarqueeCPortP )
{
	RgnHandle	theGrayRgnH;
	Pattern		theGrayPat = { 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA };
	
	OpenCPort( outMarqueeCPortP );
//	SetPort( outMarqueeCPortP );

	theGrayRgnH = GetGrayRgn();
	CopyRgn( theGrayRgnH, outMarqueeCPortP->visRgn );
	outMarqueeCPortP->portRect = ( **theGrayRgnH ).rgnBBox;
	
	ShowPen();
	PenSize( 1, 1 );
	PenPat( &theGrayPat );
	PenMode( notPatXor );
}



void
CloseMarqueeCPort(
	CGrafPtr	inMarqueeCPortP )
{
	if( inMarqueeCPortP != nil ) {
		CloseCPort( inMarqueeCPortP );
	}
}
