/*********************************************************************
 *
 * Screen saver commands passed to the SAVC selector
 *
 *********************************************************************/
enum SaverCommand {
	eSaverWakeUp,		/*  Make Basic Black wake up. */
	eSaverSleep,		/*  Make Basic Black go to sleep. */
	eSaverOn,			/*  Turn Basic Black on.  */
	eSaverOff,			/*  Turn Basic Black off. */
	eForceShort = 257	/* force enums to be shorts instead of bytes */
};

/* These are the values of the specific bit numbers for the SAVR selector: */
enum {
	gestaltSaverTurnedOn = 0,		/* saver enabled/disabled. */
	gestaltSaverAsleep,				/* saver currently asleep. */
	gestaltSaverDemoMode,			/* saver sleeping in demo mode. */
	gestaltSaverPasswordMode,		/* saver sleeping in password-protected mode. */
	gestaltAppDrawingDisabled		/* Quickdraw drawing disallowed between module animation frames. */
};

/* Icon IDs */
enum {
	kNormalIcon = 128,
	kErrorIcon,
	kOffIcon,
	kPrefIcon
};



/*********************************************************************
 *
 * Function Prototypes
 *
 *********************************************************************/
void main(void);
Boolean OpenPrefsFile(void);
void DisplayIcon(short);
void StartPatchCode(void);
pascal short MySystemEvent(EventRecord *);
pascal void sDmnSelector(OSType, long *);
pascal void SAVRSelector(OSType, long *);
pascal void SAVCSelector(OSType, long *);
pascal OSErr SaverControl(short);
void EndPatchCode(void);


/* Fake QuickDraw globals */
typedef struct {
        char    privates[76];
        long    randSeed;
        BitMap  screenBits;
        Cursor  arrow;
        Pattern dkGray;
        Pattern ltGray;
        Pattern black;
        Pattern white;
        GrafPtr thePort;
        long    qdend;
} fQDGlobals;
